/* --COPYRIGHT--,TI
 *  MSP430 Tools Source and Object Code Software License Agreement 
 *  
 *  
 *  IMPORTANT PLEASE READ THE FOLLOWING LICENSE AGREEMENT CAREFULLY.  THIS IS A LEGALLY BINDING AGREEMENT.  AFTER YOU READ THIS LICENSE AGREEMENT, YOU WILL BE ASKED WHETHER YOU ACCEPT AND AGREE TO THE TERMS OF THIS LICENSE AGREEMENT.  DO NOT CLICK "I HAVE READ AND AGREE" UNLESS: (1) YOU ARE AUTHORIZED TO ACCEPT AND AGREE TO THE TERMS OF THIS LICENSE AGREEMENT ON BEHALF OF YOURSELF AND YOUR COMPANY; AND (2) YOU INTEND TO ENTER INTO AND TO BE BOUND BY THE TERMS OF THIS LEGALLY BINDING AGREEMENT ON BEHALF OF YOURSELF AND YOUR COMPANY.
 *  
 *  
 *  Important Read carefully: This MSP430 Tools source and object code software license agreement ("Agreement") is a legal agreement between you (either an individual or entity) and Texas Instruments Incorporated ("TI").  The "Licensed Materials" subject to this Agreement include the software programs (in whole or in part) that accompany this Agreement and which you access "on-line" and/or electronic documentation (in whole or in part) associated and provided with these programs, as well as any updates or upgrades to such software programs and documentation, if any, provided to you at TI's sole discretion.  The Licensed Materials are specifically designed and licensed for use solely and exclusively with MSP430 microcontroller devices manufactured by or for TI ("TI Devices").  By installing, copying or otherwise using the Licensed Materials you agree to abide by the provisions set forth herein.  This Agreement is displayed for you to read prior to using the Licensed Materials.  If you choose not to accept or agree with these provisions, do not download or install the Licensed Materials.  
 *   
 *  
 *  1.	License Grant and Use Restrictions.   
 *  
 *  a.	Licensed Materials License Grant.   
 *  
 *  			i.	Limited Source Code License.  Subject to the terms of this Agreement, TI hereby grants to you a limited, non-transferable, non-exclusive, non-assignable, non-sublicensable, fully paid-up and royalty-free license to make copies, prepare derivative works, display internally and use internally the Licensed Materials provided to you in source code for the sole purpose of developing object and executable versions of such Licensed Materials, or any derivative thereof, that execute solely and exclusively on TI Devices, for end use in Licensee Products, and maintaining and supporting such Licensed Materials, or any derivative thereof, and Licensee Products.  For purposes of this Agreement, "Licensee Product" means a product that consists of both hardware, including one or more TI Devices, and software components, including only executable versions of the Licensed Materials that execute solely and exclusively on such TI Devices and not on devices manufactured by or for an entity other than TI.  
 *  	
 *  			ii.	Object Code Evaluation, Testing and Use License.  Subject to the terms of this Agreement, TI hereby grants to you a limited, non-transferable, non-exclusive, non-assignable, non-sublicensable, fully paid-up and royalty free license under all TI intellectual property embodied in the Licensed Materials provided to you in object code to make copies, display internally, distribute internally and use internally the Licensed Materials provided to you for the sole purposes of evaluating and testing the Licensed Materials and designing and developing Licensee Products, and maintaining and supporting the Licensee Products.  
 *  		 
 *  			iii.	Demonstration License.  Subject to the terms of this Agreement, TI hereby grants to you a limited, non-transferable, non-exclusive, non-assignable, non-sublicensable, fully paid-up and royalty free license under all TI intellectual property embodied in the Licensed Materials to demonstrate to third parties the Licensed Materials, or any derivatives thereof, executing solely and exclusively on TI Devices as they are used in Licensee Products, provided that such Licensed Materials, or any derivatives thereof, are demonstrated in object or executable versions only. 
 *  
 *  		iv.	Production and Distribution License.  Subject to the terms of this Agreement, TI hereby grants to you a non-transferable, non-exclusive, non-assignable, non-sublicensable, fully paid-up and royalty free license under all TI intellectual property embodied in the Licensed Materials to make, use, sell, offer to sell, import, export and otherwise distribute the Licensed Materials, or any derivatives thereof, as part of a Licensee Product, provided that such Licensee Products include only embedded executable copies of such Licensed Materials, or any derivatives thereof, that execute solely and exclusively on TI Devices in such Licensee Products.
 *  
 *  	b.	Contractors and Suppliers.  The licenses granted to you hereunder shall include your on-site and off-site suppliers and independent contractors, while such suppliers and independent contractors are performing work for or providing services to you, provided that such suppliers and independent contractors have executed work-for-hire agreements with you containing applicable terms and conditions consistent with the terms and conditions set forth in this Agreement and provided further that you shall be liable to TI for any breach by your suppliers or independent contractors of this Agreement to the same extent as you would be if you had breached the Agreement yourself. 
 *  
 *  	c.	Limited License to TI and Covenant not to Sue.  Continuing for the term of this Agreement, you hereby grant to TI and TI's licensees of the Licensed Materials, under any of your patents embodied in the Licensed Materials, a non-transferable, non-exclusive, non-assignable, worldwide, fully paid-up, royalty-free license to make, use, sell, offer to sell, import, export and otherwise distribute such Licensed Materials.  You covenant not to sue or otherwise assert Derived Patents against TI and TI's affiliates and their licensees of the Licensed Materials.  In the event you assign a Derived Patent, you shall require as a condition of any such assignment that the assignee agree to be bound by the provisions in this Section 1(c) with respect to such Derived Patent.  Any attempted assignment or transfer in violation of this Section 1(c) shall be null and void.  For purposes of this Agreement, "Derived Patents" means any of your patents issuing from a patent application that discloses and claims an invention conceived of by you after delivery of the Licensed Materials, and derived by you from your access to the Licensed Materials.
 *  
 *  	d.	No Other License.  Notwithstanding anything to the contrary, nothing in this Agreement shall be construed as a license to any intellectual property rights of TI other than those rights embodied in the Licensed Materials provided to you by TI.  EXCEPT AS PROVIDED HEREIN, NO OTHER LICENSE, EXPRESS OR IMPLIED, BY ESTOPPEL OR OTHERWISE, TO ANY OTHER TI INTELLECTUAL PROPERTY RIGHTS IS GRANTED HEREIN.
 *  
 *  	e.	Restrictions.  You shall maintain the source code versions of the Licensed Materials, or any derivatives thereof, under password control protection and shall not disclose such source code versions of the Licensed Materials, or any derivatives thereof, to any person other than your employees and contractors whose job performance requires access.  You shall not use the Licensed Materials, or any derivatives thereof, with a processing device manufactured by or for an entity other than TI, and you agree that any such unauthorized use of the Licensed Materials, or any derivatives thereof, is a material breach of this Agreement.  Except as expressly provided in this Agreement, you shall not copy, publish, disclose, display, provide, transfer or make available the Licensed Materials, or any derivatives thereof, to any third party and you shall not sublicense, transfer, or assign the Licensed Materials, or any derivatives thereof, or your rights under this Agreement to any third party.  You shall not mortgage, pledge or encumber the Licensed Materials, or any derivatives thereof, in any way.  You may use the Licensed Materials, or any derivatives thereof, with Open Source Software or with software developed using Open Source Software tools provided you do not incorporate, combine or distribute the Licensed Materials, or any derivatives thereof, in a manner that subjects the Licensed Materials, or any derivatives thereof, to any license obligations or any other intellectual property related terms of any license governing such Open Source Software.   "Open Source Software" means any software licensed under terms requiring that (A) other software ("Proprietary Software") incorporated, combined or distributed with such software or developed using such software: (i) be disclosed or distributed in source code form; or (ii) otherwise be licensed on terms inconsistent with the terms of this Agreement, including but not limited to permitting use of the Proprietary Software on or with devices other than TI Devices, or (B) require the owner of Proprietary Software to license any of its patents to users of the Open Source Software and/or Proprietary Software incorporated, combined or distributed with such Open Source Software or developed using such Open Source Software. 
 *    
 *  		f.	Termination.  This Agreement is effective until terminated.  You may terminate this Agreement at any time by written notice to TI.  Without prejudice to any other rights, if you fail to comply with the terms of this Agreement, TI may terminate your right to use the Licensed Materials, or any derivatives thereof, upon written notice to you.  Upon termination of this Agreement, you will destroy any and all copies of the Licensed Materials, or any derivatives thereof, in your possession, custody or control and provide to TI a written statement signed by your authorized representative certifying such destruction. Except for Sections 1(a) and 1(b) and the limited license to TI in Section 1(c), all provisions of this Agreement shall survive termination of this Agreement. 
 *  
 *  2.	Licensed Materials Ownership.  The Licensed Materials are licensed, not sold to you, and can only be used in accordance with the terms of this Agreement.  Subject to the licenses granted to you pursuant to this Agreement, TI and its licensors own and shall continue to own all right, title, and interest in and to the Licensed Materials, including all copies thereof.  The parties agree that all fixes, modifications and improvements to the Licensed Materials conceived of or made by TI that are based, either in whole or in part, on your feedback, suggestions or recommendations are the exclusive property of TI and all right, title and interest in and to such fixes, modifications or improvements to the Licensed Materials will vest solely in TI.  Moreover, you acknowledge and agree that when your independently developed software or hardware components are combined, in whole or in part, with the Licensed Materials, your right to use the combined work that includes the Licensed Materials remains subject to the terms and conditions of this Agreement.
 *  
 *  3.	Intellectual Property Rights.  
 *  
 *  	a.	The Licensed Materials contain copyrighted material, trade secrets and other proprietary information of TI and its licensors and are protected by copyright laws, international copyright treaties, and trade secret laws, as well as other intellectual property laws.  To protect TI's and its licensors' rights in the Licensed Materials, you agree, except as specifically permitted by statute by a provision that cannot be waived by contract, not to "unlock", decompile, reverse engineer, disassemble or otherwise translate to a human-perceivable form any portions of the Licensed Materials provided to you in object code format only, nor permit any person or entity to do so.  You shall not remove, alter, cover, or obscure any confidentiality, trade secret, trade mark, patent, copyright or other proprietary notice or other identifying marks or designs from any component of the Licensed Materials and you shall reproduce and include in all copies of the Licensed Materials, or any derivatives thereof, the copyright notice(s) and proprietary legend(s) of TI and its licensors as they appear in the Licensed Materials.  TI reserves all rights not specifically granted under this Agreement.
 *  
 *  	b.	Certain Licensed Materials may be based on industry recognized standards or software programs published by industry recognized standards bodies and certain third parties may claim to own patents, copyrights, and other intellectual property rights that cover implementation of those standards.  You acknowledge and agree that this Agreement does not convey a license to any such third party patents, copyrights, and other intellectual property rights and that you are solely responsible for any patent, copyright, or other intellectual property right claim that relates to your use or distribution of the Licensed Materials, or any derivatives thereof,, or your use or distribution of your products that include or incorporate the Licensed Materials, or any derivatives thereof,.  Moreover, you acknowledge that you are responsible for any fees or royalties that may be payable to any third party based on such third party's interests in the Licensed Materials or any intellectual property rights that cover implementation of any industry recognized standard, any software program published by any industry recognized standards bodies or any other proprietary technology.
 *  		
 *  4.	Audit Right.  At TI's request, and within thirty (30) days after receiving written notice, you shall permit an independent auditor selected by TI to have access, no more than twice each calendar year (unless the immediately preceding audit revealed a discrepancy) and during your regular business hours, to all of your equipment, records, and documents as may contain information bearing upon the use of the Licensed Materials, or any derivatives thereof.  You shall keep full, complete, clear and accurate records with respect to product sales and distributions for a period beginning with the then-current calendar year and going back three (3) years.
 *  
 *  5.	Confidential Information.  You acknowledge and agree that the Licensed Materials contain trade secrets and other confidential information of TI its licensors.  You agree to use the Licensed Materials, or any derivatives thereof, solely within the scope of the licenses set forth herein, to maintain the Licensed Materials, or any derivatives thereof, in strict confidence, to use at least the same procedures and degree of care that you use to prevent disclosure of your own confidential information of like importance but in no instance less than reasonable care, and to prevent disclosure of the Licensed Materials, or any derivatives thereof, to any third party, except as may be necessary and required in connection with your rights and obligations hereunder.  You agree to obtain executed confidentiality agreements with your employees and contractors having access to the Licensed Materials, or any derivatives thereof, and to diligently take steps to enforce such agreements in this respect.  TI agrees that industry standard employment agreements used in the normal course of your business shall satisfy the requirements of this section. TI may disclose your contact information to TI's licensors.
 *  
 *  6.	Warranties and Limitations.  THE LICENSED MATERIALS ARE PROVIDED "AS IS".  FURTHERMORE, YOU ACKNOWLEDGE AND AGREE THAT THE LICENSED MATERIALS HAVE NOT BEEN TESTED OR CERTIFIED BY ANY GOVERNMENT AGENCY OR INDUSTRY REGULATORY ORGANIZATION OR ANY OTHER THIRD PARTY ORGANIZATION.  YOU AGREE THAT PRIOR TO USING, INCORPORATING OR DISTRIBUTING THE LICENSED MATERIALS, OR ANY DERIVATIVES THEREOF, IN OR WITH ANY COMMERCIAL PRODUCT THAT YOU WILL THOROUGHLY TEST THE PRODUCT AND THE FUNCTIONALITY OF THE LICENSED MATERIALS, OR ANY DERIVATIVES THEREOF, IN OR WITH THAT PRODUCT AND BE SOLELY RESPONSIBLE FOR ANY PROBLEMS OR FAILURES.
 *  
 *  TI AND ITS LICENSORS MAKE NO WARRANTY OR REPRESENTATION, EITHER EXPRESS, IMPLIED OR STATUTORY, REGARDING THE LICENSED MATERIALS, INCLUDING BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT OF ANY THIRD PARTY PATENTS, COPYRIGHTS, TRADE SECRETS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  YOU AGREE TO USE YOUR INDEPENDENT JUDGMENT IN DEVELOPING YOUR PRODUCTS.  NOTHING CONTAINED IN THIS AGREEMENT WILL BE CONSTRUED AS A WARRANTY OR REPRESENTATION BY TI TO MAINTAIN PRODUCTION OF ANY TI SEMICONDUCTOR DEVICE OR OTHER HARDWARE OR SOFTWARE WITH WHICH THE LICENSED MATERIALS, OR ANY DERIVATIVES THEREOF, MAY BE USED.  
 *  
 *  IN NO EVENT SHALL TI OR ITS LICENSORS, BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL, PUNITIVE OR CONSEQUENTIAL DAMAGES, HOWEVER CAUSED, ON ANY THEORY OF LIABILITY, IN CONNECTION WITH OR ARISING OUT OF THIS AGREEMENT OR THE USE OF THE LICENSED MATERIALS, OR ANY DERIVATIVES THEREOF, REGARDLESS OF WHETHER TI HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.  EXCLUDED DAMAGES INCLUDE, BUT ARE NOT LIMITED TO, COST OF REMOVAL OR REINSTALLATION, OUTSIDE COMPUTER TIME, LABOR COSTS, LOSS OF DATA, LOSS OF GOODWILL, LOSS OF PROFITS, LOSS OF SAVINGS, OR LOSS OF USE OR INTERRUPTION OF BUSINESS.  IN NO EVENT WILL TI'S OR ITS LICENSORS' AGGREGATE LIABILITY UNDER THIS AGREEMENT OR ARISING OUT OF YOUR USE OF THE LICENSED MATERIALS, OR ANY DERIVATIVES THEREOF, EXCEED THE GREATER OF FIVE HUNDRED U.S. DOLLARS (US$500) OR THE FEES PAID TO TI BY YOU FOR THE LICENSED MATERIALS UNDER THIS AGREEMENT.
 *  
 *  	Because some jurisdictions do not allow the exclusion or limitation of incidental or consequential damages or limitation on how long an implied warranty lasts, the above limitations or exclusions may not apply to you.
 *  
 *  7.	Indemnification Disclaimer.  YOU ACKNOWLEDGE AND AGREE THAT TI SHALL NOT BE LIABLE FOR AND SHALL NOT DEFEND OR INDEMNIFY YOU AGAINST ANY THIRD PARTY INFRINGEMENT CLAIM THAT RELATES TO OR IS BASED ON YOUR MANUFACTURE, USE, OR DISTRIBUTION OF THE LICENSED MATERIALS, OR ANY DERIVATIVES THEREOF, OR YOUR MANUFACTURE, USE, OFFER FOR SALE, SALE, IMPORTATION OR DISTRIBUTION OF YOUR PRODUCTS THAT INCLUDE OR INCORPORATE THE LICENSED MATERIALS, OR ANY DERIVATIVES THEREOF,.
 *  
 *  8.	No Technical Support.  TI and its licensors are under no obligation to install, maintain or support the Licensed Materials, or any derivatives thereof.  
 *  
 *  9.	Notices.  All notices to TI hereunder shall be delivered to Texas Instruments Incorporated, 12500 TI Boulevard, Mail Station 8638, Dallas, Texas 75243, Attention: Contracts Manager, with a copy to Texas Instruments Incorporated, 13588 North Central Expressway, MS 3999, Dallas, TX 75243, 	Attention: Law Department - ASP.  All notices shall be deemed served when received by TI. 
 *  
 *  10.	Export Control.  You hereby acknowledge that the Licensed Materials are subject to export control under the U.S. Commerce Department's Export Administration Regulations ("EAR").  You further hereby acknowledge and agree that unless prior authorization is obtained from the U.S. Commerce Department, neither you nor your customers will export, re-export, or release, directly or indirectly, any technology, software, or software source code (as defined in Part 772 of the EAR), received from TI, or export, directly or indirectly, any direct product of such technology, software, or software source code (as defined in Part 734 of the EAR), to any destination or country to which the export, re-export, or release of the technology, software, or software source code, or direct product is prohibited by the EAR.  You agree that none of the Licensed Materials may be downloaded or otherwise exported or reexported (i) into (or to a national or resident of) Cuba, Iran, North Korea, Sudan and Syria or any other country the U.S. has embargoed goods; or (ii) to anyone on the U.S. Treasury Department's List of Specially Designated Nationals or the U.S. Commerce Department's Denied Persons List or Entity List.  You represent and warrant that you are not located in, under the control of, or a national or resident of any such country or on any such list and you will not use or transfer the Licensed Materials, or any derivatives thereof, for use in any sensitive nuclear, chemical or biological weapons, or missile technology end-uses unless authorized by the U.S. Government by regulation or specific license or for a military end-use in, or by any military entity of Albania, Armenia, Azerbaijan, Belarus, Cambodia, China, Georgia, Iraq, Kazakhstan, Kyrgyzstan, Laos, Libya, Macau, Moldova, Mongolia, Russia, Tajikistan, Turkmenistan, Ukraine, Uzbekistan, and Vietnam. Any software export classification made by TI shall be for TI's internal use only and shall not be construed as a representation or warranty regarding the proper export classification for such software or whether an export license or other documentation is required for the exportation of such software. 
 *  
 *  11.	Governing Law and Severability; Waiver.  This Agreement will be governed by and interpreted in accordance with the laws of the State of Texas, without reference to conflict of laws principles.  If for any reason a court of competent jurisdiction finds any provision of the Agreement to be unenforceable, that provision will be enforced to the maximum extent possible to effectuate the intent of the parties, and the remainder of the Agreement shall continue in full force and effect.  This Agreement shall not be governed by the United Nations Convention on Contracts for the International Sale of Goods, or by the Uniform Computer Information Transactions Act (UCITA).  The parties agree that non-exclusive jurisdiction for any dispute arising out of or relating to this Agreement lies within the courts located in the State of Texas.  Notwithstanding the foregoing, any judgment may be enforced in any United States or foreign court, and either party may seek injunctive relief in any United States or foreign court.  Failure by TI to enforce any provision of this Agreement shall not be deemed a waiver of future enforcement of that or any other provision in this Agreement or any other agreement that may be in place between the parties.
 *  
 *  12.	PRC Provisions.  If you are located in the People's Republic of China ("PRC") or if the Licensed Materials, or any derivatives thereof, will be sent to the PRC, the following provisions shall apply and shall supersede any other provisions in this Agreement concerning the same subject matter:  
 *  
 *  	a.	Registration Requirements.  You shall be solely responsible for performing all acts and obtaining all approvals that may be required in connection with this Agreement by the government of the PRC, including but not limited to registering pursuant to, and otherwise complying with, the PRC Measures on the Administration of Software Products, Management Regulations on Technology Import-Export, and Technology Import and Export Contract Registration Management Rules.  Upon receipt of such approvals from the government authorities, you shall forward evidence of all such approvals to TI for its records.  In the event that you fail to obtain any such approval or registration, you shall be solely responsible for any and all losses, damages or costs resulting therefrom, and shall indemnify TI for all such losses, damages or costs.
 *  
 *  b.	Governing Language.  This Agreement is written and executed in the English language.  If a translation of this Agreement is required for any purpose, including but not limited to registration of the Agreement pursuant to any governmental laws, regulations or rules, you shall be solely responsible for creating such translation.  Any translation of this Agreement into a language other than English is intended solely in order to comply with such laws or for reference purposes, and the English language version shall be authoritative and controlling.
 *  
 *  c.	Export Control.
 *  
 *  i.	Diversions of Technology.  You hereby agree that unless prior authorization is obtained from the U.S. Department of Commerce, neither you nor your subsidiaries or affiliates shall knowingly export, re-export, or release, directly or indirectly, any technology, software, or software source code (as defined in Part 772 of the Export Administration Regulations of the U.S. Department of Commerce ("EAR")), received from TI or any of its affiliated companies, or export, directly or indirectly, any direct product of such technology, software, or software source code (as defined in Part 734 of the EAR), to any destination or country to which the export, re-export, or release of the technology, software, software source code, or direct product is prohibited by the EAR.
 *  
 *  ii.	Assurance of Compliance.  You understand and acknowledge that products, technology (regardless of the form in which it is provided), software or software source code, received from TI or any of its affiliates under this Agreement may be under export control of the United States or other countries.  You shall comply with the United States and other applicable non-U.S. laws and regulations governing the export, re-export and release of any products, technology, software, or software source code received under this Agreement from TI or its affiliates.  You shall not undertake any action that is prohibited by the EAR.  Without limiting the generality of the foregoing, you specifically agree that you shall not transfer or release products, technology, software, or software source code of TI or its affiliates to, or for use by, military end users or for use in military, missile, nuclear, biological, or chemical weapons end uses.
 *  	
 *  iii.  Licenses.  Each party shall secure at its own expense, such licenses and export and import documents as are necessary for each respective party to fulfill its obligations under this Agreement.  If such licenses or government approvals cannot be obtained, TI may terminate this Agreement, or shall otherwise be excused from the performance of any obligations it may have under this Agreement for which the licenses or government approvals are required.
 *  
 *  13.	Entire Agreement.  This is the entire Agreement between you and TI and this Agreement supersedes any prior agreement between the parties related to the subject matter of this Agreement.  Notwithstanding the foregoing, any signed and effective software license agreement relating to the subject matter hereof and stating expressly that such agreement shall control regardless of any subsequent click-wrap, shrink-wrap or web-wrap, shall supersede the terms of this Agreement.  No amendment or modification of this Agreement will be effective unless in writing and signed by a duly authorized representative of TI.  You hereby warrant and represent that you have obtained all authorizations and other applicable consents required empowering you to enter into this Agreement.
 *  
 * --/COPYRIGHT--*/
#include "msp430x54xA.h"
//#include "intrinsics.h"

//Device Specific Definitions
#define MASS_ERASE_DELAY 0x8000
#define INTERRUPT_VECTOR_START 0xFFE0
#define INTERRUPT_VECTOR_END   0xFFFF
#define SECURE_RAM_START 0x1C00


#define TX_PORT_SEL P1SEL
#define TX_PORT_DIR P1DIR
#define RX_PORT_SEL P1SEL
#define RX_PORT_DIR P1DIR
#define RXD       BIT2                      // RXD on P1.2 
#define TXD       BIT1                      // TXD on P1.1
#define DCO_SPEED 8000000
#define ACLK_SPEED 32768

#define TZNCCTL_TX TA0CCTL0
#define TZNCCTL_RX TA0CCTL1
#define TZNCCR_TX  TA0CCR0
#define TZNCCR_RX  TA0CCR1
#define TZNCTL     TA0CTL
#define TZ_CLK_SEL TASSEL_2
#define TZNR       TA0R

//Device Specific Definitions for commands and bugs
#define DO_NOT_CHECK_VPE

// standard command includes
#ifdef RAM_WRITE_ONLY_BSL
 #define SUPPORTS_RX_DATA_BLOCK_FAST
 #define SUPPORTS_RX_PASSWORD
 #define SUPPORTS_LOAD_PC
#endif

#define PROGRAMMING_FUNCTIONS
//#define MEMORY_READING_FUNCTIONS
//#define OTHER_FUNCTIONS

#ifdef PROGRAMMING_FUNCTIONS
 #define SUPPORTS_RX_PASSWORD
 #define SUPPORTS_ERASE_SEGMENT
 #define SUPPORTS_TOGGLE_INFO
 #define SUPPORTS_RX_DATA_BLOCK
 #define SUPPORTS_CRC_CHECK
#endif

#ifdef MEMORY_READING_FUNCTIONS
 #define SUPPORTS_RX_PASSWORD
 #define SUPPORTS_TX_DATA_BLOCK
 #define SUPPORTS_CRC_CHECK
#endif

#ifdef OTHER_FUNCTIONS
 #define SUPPORTS_RX_DATA_BLOCK_FAST
 #define SUPPORTS_TX_BSL_VERSION
 #define SUPPORTS_MASS_ERASE
 #define SUPPORTS_LOAD_PC
#endif

